#include once "windows.bi"
#include once "vbcompat.bi"

sub CopyFileTimeStamps( byref src as string, byref dst as string )

	dim as HANDLE hFile
	dim as FILETIME c, a, l
	
	print "Setting '" & dst & "': ";

	hFile = CreateFile( src, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL )
	if( hFile ) then
	
		if( GetFileTime( hFile, @c, @a, @l ) ) then
			
			CloseHandle( hFile )

			hFile = CreateFile( dst, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL )
			if( hFile ) then
				if( SetFileTime( hFile, @c, @a, @l ) ) then
					print "OK"
				else
					print "Unable to set time"
				end if
				CloseHandle( hFile )
			else
				print "Unable to open file"
			end if

		else

			CloseHandle( hFile )
			print "Unable to read times"

		end if

	else
		print "Could not open '" & src & "' file."

	end if

end sub

sub StripCRLF( byref src as string, byref dst as string )

	dim as string x, y
	dim as integer i, j

	open src for binary as #1
	x = space(lof(1))
	get #1,,x
	close #1

	y = ""

	i = 1
	while i <= len(x)
		if mid( x, i, 2 ) = chr( 13, 10 ) then
			y = y & chr(10)
			i += 2
		else
			y = y & mid( x, i, 1 )
			i += 1
		end if
	wend

	open dst for output as #1
	close #1

	open dst for output as #1
	put #1,,y
	close #1

end sub


'' ==========
'' MAIN
'' ==========

#define OPT_LF 1
#define OPT_BOTH 2

dim files(1 to 100) as string
dim opts(1 to 100) as integer
dim nfiles as integer = 0
dim as integer i
dim as string base_dir = "../"
dim as string x
dim as integer opt

opt = 0

open "crlf.lst" for input as #1
while eof(1) = 0
	line input #1, x
	x = trim(x)
	if( left(x,1) = "[" ) then
		select case lcase(mid(x,2,len(x)-2))
		case "lf"
			opt = OPT_LF
		case "both"
			opt = OPT_BOTH
		case else
			print "Unknown option '" & x & "'"
		end select
	else
		if( x > "" ) then
			nfiles += 1
			files(nfiles) = x
			opts(nfiles) = opt
		end if
	end if
wend
close #1

select case lcase(command(1))
case "copy"

	for i = 1 to nfiles
		print "Copying '" & base_dir & files(i) & "' to '" & base_dir & files(i) & ".bak" & "'"
		FileCopy base_dir & files(i), base_dir & files(i) & ".bak"
	next

case "strip"

	for i = 1 to nfiles
		StripCRLF          base_dir & files(i) & ".bak", base_dir & files(i)
		CopyFileTimeStamps base_dir & files(i) & ".bak", base_dir & files(i)
	next i

case "restore"
	
	for i = 1 to nfiles
		print "Restoring'" & base_dir & files(i) & ".bak" & "' to '" & base_dir & files(i) & "'"
		FileCopy base_dir & files(i) & ".bak", base_dir & files(i)
	next i

case "win32", "dos"

	for i = 1 to nfiles	
		if( fileexists( base_dir & files(i) & ".bak" ) = FALSE ) then
			print "Copying '" & base_dir & files(i) & "' to '" & base_dir & files(i) & ".bak" & "'"
			FileCopy base_dir & files(i), base_dir & files(i) & ".bak"
		end if
		if( opts(i) = OPT_BOTH ) then
			if( fileexists( base_dir & files(i) & ".bak" ) <> FALSE ) then
				print "Copying '" & base_dir & files(i) & ".bak" & "' to '" & base_dir & files(i) & "'"
				FileCopy base_dir & files(i) & ".bak", base_dir & files(i)
			end if
		end if
	next

case "linux"

	for i = 1 to nfiles
		if( fileexists( base_dir & files(i) & ".bak" ) = FALSE ) then
			print "Copying '" & base_dir & files(i) & "' to '" & base_dir & files(i) & ".bak" & "'"
			FileCopy base_dir & files(i), base_dir & files(i) & ".bak"
		end if
		if( fileexists( base_dir & files(i) & ".bak" ) <> FALSE ) then
			print "stripping '" & base_dir & files(i) & ".bak" & "' to '" & base_dir & files(i) & "'"
			StripCRLF          base_dir & files(i) & ".bak", base_dir & files(i)
			CopyFileTimeStamps base_dir & files(i) & ".bak", base_dir & files(i)
		end if
	next

case "check"

	dim b as integer

	print "Checking files ... "

	for i = 1 to nfiles

		'' Is .bak file missing or older, then do copy

		if( fileexists( base_dir & files(i) & ".bak" ) = FALSE ) then
			b = 1
		elseif( filedatetime( base_dir & files(i) & ".bak" ) _
			< filedatetime( base_dir & files(i) ) ) then
			b = 1
		else
			b = 0
		end if

		if( b = 1 ) then

			print "Copying '" & base_dir & files(i) & "' to '" & base_dir & files(i) & ".bak" & "'"
			FileCopy base_dir & files(i), base_dir & files(i) & ".bak"

			if( opts(i) = OPT_LF ) then

				StripCRLF          base_dir & files(i) & ".bak", base_dir & files(i)
				CopyFileTimeStamps base_dir & files(i) & ".bak", base_dir & files(i)

			end if

		end if

	next i

case "lf"

	for i = 1 to nfiles	
		if( fileexists( base_dir & files(i) & ".bak" ) = FALSE ) then
			print "Copying '" & base_dir & files(i) & "' to '" & base_dir & files(i) & ".bak" & "'"
			FileCopy base_dir & files(i), base_dir & files(i) & ".bak"
		end if
		if( opts(i) = OPT_LF ) then
			if( fileexists( base_dir & files(i) & ".bak" ) <> FALSE ) then
				StripCRLF          base_dir & files(i) & ".bak", base_dir & files(i)
				CopyFileTimeStamps base_dir & files(i) & ".bak", base_dir & files(i)
			end if
		end if
	next

case else

	print "crlf {copy|strip|restore|check|dos|win32|linux|lf}"
	end 1

end select
