const BUFSIZE = 65536

enum
	ERR_SUCCESS = 0
	ERR_FILE1_NOT_SPECIFIED
	ERR_FILE2_NOT_SPECIFIED
	ERR_FILE1_NOT_FOUND
	ERR_FILE2_NOT_FOUND
	ERR_FILES_DIFFERENT_LENGTHS
	ERR_FILES_DIFFERENT_CONTENTS
	ERR_INVALID_ARGUMENTS
end enum

function CompareFiles( byref f1 as string, byref f2 as string, byval start as integer ) as integer

	function = 0

	dim h1 as integer, h2 as integer
	dim l1 as integer, l2 as integer, n as integer
	dim b1 as string, b2 as string

	if( f1 = "" ) then
		function = ERR_FILE1_NOT_SPECIFIED
		exit function
	end if

	if( f2 = "" ) then
		function = ERR_FILE2_NOT_SPECIFIED
		exit function
	end if
	
	h1 = freefile
	if( open( f1 for binary access read as #h1 ) = 0 ) then
		h2 = freefile
		if( open( f2 for binary access read as #h2 ) = 0 ) then
			l1 = lof(h1)
			l2 = lof(h2)
			if( l1 <> l2 ) then
				function = ERR_FILES_DIFFERENT_LENGTHS
			elseif( start < n ) then

				n = l1

				if( start > 0 ) then
					n -= start
					b1 = space( start )
					b2 = space( start )
					get #h1,,b1
					get #h2,,b2
				end if

				b1 = space( BUFSIZE )
				b2 = space( BUFSIZE )

				while( n > 0 )

					if( n < BUFSIZE ) then
						b1 = space( n )
						b2 = space( n )
						n = 0
					else
						n -= BUFSIZE
					end if

					get #h1,,b1
					get #h2,,b2

					if( b1 <> b2 ) then
						function = ERR_FILES_DIFFERENT_CONTENTS
						exit while
					end if

				wend
			
			end if
			close #h1
			close #h2		

		else
			close #h1
			function = ERR_FILE2_NOT_FOUND
		end if
	else
		function = ERR_FILE1_NOT_FOUND
	end if

end function

dim ret as integer

if( command(1) = "" and command(2) = "" ) then
	print "diffexe file1 file2 start"
	ret = ERR_INVALID_ARGUMENTS
else
	ret = CompareFiles( command(1), command(2), val( command(3) ) )	
end if

select case ret
case ERR_FILE1_NOT_SPECIFIED
	print "File 1 not specified"
case ERR_FILE2_NOT_SPECIFIED
	print "File 2 not specified"
case ERR_FILE1_NOT_FOUND
	print "'" & command(1) & "' not found"
case ERR_FILE2_NOT_FOUND
	print "'" & command(2) & "' not found"
case ERR_FILES_DIFFERENT_LENGTHS
	print "'" & command(1) & "' and '" & command(2) & " are different lengths"
case ERR_FILES_DIFFERENT_CONTENTS
	print "'" & command(1) & "' and '" & command(2) & " have different contents"
case ERR_INVALID_ARGUMENTS
	print "Invalid arguemnts"
end select

end ret
