#include once "file.bi"

const FALSE=0, TRUE=NOT FALSE

''
dim shared as string revision, svn_exe, svn_base_url, svn_url
dim shared as string build_drv, build_dir, build_path
dim shared as string batch_file, stat_path, work_path

''
function ReplaceSubStr _
	( _
		byval src as zstring ptr, _
		byval old as zstring ptr, _
		byval rep as zstring ptr _
	) as string 

   dim i as integer = 1, ret as string 
   ret = *src 
   do 
	  i = instr(i, ret, *old) 
	  if i = 0 then exit do 
	  ret = left(ret, i - 1) + *rep + mid(ret, i + len(*old)) 
	  i += len(*rep) 
   loop 
   return ret 
end function

''
sub outp( byref text as string = "" )

	dim h as integer
	h = freefile
	if( open( batch_file for append as #h ) = 0 ) then
		print #h, text
		close #h		
	end if

end sub

''								    
sub oute( byref text as string = "" )

	dim ret as string
	ret = text
	if( ret > "" ) then
		ret = ReplaceSubStr( ret, "${BUILD_DRV}", build_drv )
		ret = ReplaceSubStr( ret, "${BUILD_DIR}", build_dir )
		ret = ReplaceSubStr( ret, "${BUILD_PATH}", build_path )
		ret = ReplaceSubStr( ret, "${STAT_PATH}", stat_path )
		ret = ReplaceSubStr( ret, "${WORK_PATH}", work_path )
		ret = ReplaceSubStr( ret, "${SVN}", svn_exe )
		ret = ReplaceSubStr( ret, "${URL}", svn_url )
	end if

	outp ret

end sub

''
sub outcomment( byref text as string = "" )
	outp "REM ============================================================"
	if( text > "" ) then
		outp "REM " & text
	end if
end sub

''
function GetLabel( byref prefix as string ) as string
	static n as integer
	n += 1
	if( prefix > "" ) then
		function = ucase(left( prefix, 4 )) & right( "00" & str(n), 2 )
	else
		function = "LBL" & right( "00" & str(n), 2 )
	end if
end function

''
sub MarkProgress( byref mark as string )
	oute "echo complete > ${STAT_PATH}\" & mark & ".tmp"
end sub

''
sub CheckProgress( byref mark as string, byref label as string )
	oute "IF EXIST ${STAT_PATH}\" & mark & ".tmp goto " & label
end sub

''
sub ClearProgress( byref mark as string )
	oute "IF EXIST ${STAT_PATH}\" & mark & ".tmp del " & mark & ".tmp"
end sub

''
sub gen_startup()

	dim lbl as string, f as string
	f = "begin"

	MarkProgress f

end sub

''
sub gen_svn_checkout( byval exportonly as integer = 0 )

	dim lbl as string, f as string
	lbl = GetLabel( "SVN" )
	f = "svnexprt"

	outcomment "Get the source from SVN if we don't have it already"
	oute
	CheckProgress f, lbl
	oute
	if( exportonly ) then
		oute "${SVN} export ${URL} ${BUILD_PATH}"
	else
		oute "mkdir ${BUILD_PATH}"
		oute "${SVN} checkout ${URL} ${BUILD_PATH}"
	end if
	oute "if errorlevel 1 goto ERROR"
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute 

end sub

''
sub gen_copy_extra_files()
	outcomment "Copy extra files"
	oute
	oute "copy f:\freebasic\lib\dos\libcunit.a g:\freebasic\lib\dos\libcunit.a"
/'
	oute "copy f:\freebasic\examples\manual\samples.bas g:\freebasic\examples\manual\samples.bas"
	oute "copy f:\freebasic\examples\manual\samples.ini g:\freebasic\examples\manual\samples.ini"
	oute "copy f:\freebasic\examples\manual\strings\wstr.bas g:\freebasic\examples\manual\strings\wstr.bas"
	oute "copy f:\freebasic\src\gfxlib2\libfb_gfx_screen.c g:\freebasic\src\gfxlib2\libfb_gfx_screen.c"
	oute "copy f:\freebasic\tests\cunit-tests.mk g:\freebasic\tests\cunit-tests.mk"
'/
	oute
end sub

''
sub gen_autoconf()

	dim lbl as string, f as string
	lbl = GetLabel( "ACNF" )
	f = "autoconf"

	outcomment "Remake the input files needed configure"
	oute
	CheckProgress f, lbl
	oute
	oute "call setpath.bat DJS" '' !!!
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\src"
	oute
	oute "cd rtlib"
	oute "sh autoconf"
	oute "if errorlevel 1 goto ERROR"
	oute "deltree /y autom4te.cache"
	oute "cd .."
	oute
	oute "cd gfxlib2"
	oute "sh autoconf"
	oute "if errorlevel 1 goto ERROR"
	oute "deltree /y autom4te.cache"
	oute "cd .."
	oute
	oute "cd compiler"
	oute "sh autoconf"
	oute "if errorlevel 1 goto ERROR"
	oute "deltree /y autom4te.cache"
	oute "cd .."
	oute
	oute "cd ..\.."
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

''
sub gen_configure_win( byref fbcset as string, byref flags1 as string, byref flags2 as string )

	dim lbl as string, f as string
	lbl = GetLabel( "WCNF" )
	f = "conf_win"

	outcomment "configure rtlib, gfxlib2, and compiler for windows"
	oute
	CheckProgress f, lbl
	oute
	oute "call setpath.bat " & fbcset '' !!!
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\src"
	oute
	oute "cd rtlib\obj\win32"
	oute "sh ../../configure " & flags1
	oute "if errorlevel 1 goto ERROR"
	oute "cd ..\..\.."
	oute
	oute "cd gfxlib2\obj\win32"
	oute "sh ../../configure " & flags1
	oute "if errorlevel 1 goto ERROR"
	oute "cd ..\..\.."
	oute
	oute "cd compiler\obj\win32"
	oute "sh ../../configure " & flags2
	oute "if errorlevel 1 goto ERROR"
	oute "cd ..\..\.."
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

	lbl = GetLabel( "WSTR" )
	f = "strp_win"

	CheckProgress f, lbl
	oute
	oute "call setpath.bat MINGW"  '' !!!
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\src"
	oute
	oute "copy compiler\obj\win32\config.status compiler\obj\win32\config.status.bak"
	oute "sed 's/\/${BUILD_DRV}\/${BUILD_DIR}\/src\/config\/missing //g' < compiler\obj\win32\config.status.bak > compiler\obj\win32\config.status"
	oute "touch -m --reference=compiler\obj\win32\config.status.bak compiler\obj\win32\config.status"
	oute
	oute "copy compiler\obj\win32\Makefile compiler\obj\win32\Makefile.bak"
	oute "sed 's/\/${BUILD_DRV}\/${BUILD_DIR}\/src\/config\/missing //g' < compiler\obj\win32\Makefile.bak > compiler\obj\win32\Makefile"
	oute "touch -m --reference=compiler\obj\win32\Makefile.bak compiler\obj\win32\Makefile"
	oute
	oute "copy rtlib\obj\win32\config.status rtlib\obj\win32\config.status.bak"
	oute "sed 's/\/${BUILD_DRV}\/${BUILD_DIR}\/src\/config\/missing //g' < rtlib\obj\win32\config.status.bak > rtlib\obj\win32\config.status"
	oute "touch -m --reference=rtlib\obj\win32\config.status.bak rtlib\obj\win32\config.status"
	oute
	oute "copy gfxlib2\obj\win32\config.status gfxlib2\obj\win32\config.status.bak"
	oute "sed 's/\/${BUILD_DRV}\/${BUILD_DIR}\/src\/config\/missing //g' < gfxlib2\obj\win32\config.status.bak > gfxlib2\obj\win32\config.status"
	oute "touch -m --reference=gfxlib2\obj\win32\config.status.bak gfxlib2\obj\win32\config.status"
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

''
sub gen_configure_dos( byref fbcset as string, byref flags1 as string, byref flags2 as string )

	dim lbl as string, f as string
	lbl = GetLabel( "DCNF" )
	f = "conf_dos"

	outcomment "configure rtlib, gfxlib2, and compiler for dos"
	oute
	CheckProgress f, lbl
	oute
	oute "call setpath.bat " & fbcset
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\src"
	oute
	oute "cd rtlib\obj\dos"
	oute "sh ../../configure " & flags1
	oute "if errorlevel 1 goto ERROR"
	oute "cd ..\..\.."
	oute
	oute "cd gfxlib2\obj\dos"
	oute "sh ../../configure " & flags1
	oute "if errorlevel 1 goto ERROR"
	oute "cd ..\..\.."
	oute
	oute "cd compiler\obj\dos"
	oute "sh ../../configure " & flags2
	oute "if errorlevel 1 goto ERROR"
	oute "cd ..\..\.."
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

	lbl = GetLabel( "DSTR" )
	f = "strp_dos"

	CheckProgress f, lbl
	oute
	oute "call setpath.bat MINGW"
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\src"
	oute
	oute "copy compiler\obj\dos\config.status compiler\obj\dos\config.status.bak"
	oute "sed 's/${BUILD_DRV}:\/${BUILD_DIR}\/src\/config\/missing //g' < compiler\obj\dos\config.status.bak > compiler\obj\dos\config.status"
	oute "touch -m --reference=compiler\obj\dos\config.status.bak compiler\obj\dos\config.status"
	oute
	oute "copy compiler\obj\dos\Makefile compiler\obj\dos\Makefile.bak"
	oute "sed 's/${BUILD_DRV}:\/${BUILD_DIR}\/src\/config\/missing //g' < compiler\obj\dos\Makefile.bak > compiler\obj\dos\Makefile"
	oute "touch -m --reference=compiler\obj\dos\Makefile.bak compiler\obj\dos\Makefile"
	oute
	oute "copy rtlib\obj\dos\config.status rtlib\obj\dos\config.status.bak"
	oute "sed 's/${BUILD_DRV}:\/${BUILD_DIR}\/src\/config\/missing //g' < rtlib\obj\dos\config.status.bak > rtlib\obj\dos\config.status"
	oute "touch -m --reference=rtlib\obj\dos\config.status.bak rtlib\obj\dos\config.status"
	oute
	oute "copy gfxlib2\obj\dos\config.status gfxlib2\obj\dos\config.status.bak"
	oute "sed 's/${BUILD_DRV}:\/${BUILD_DIR}\/src\/config\/missing //g' < gfxlib2\obj\dos\config.status.bak > gfxlib2\obj\dos\config.status"
	oute "touch -m --reference=gfxlib2\obj\dos\config.status.bak gfxlib2\obj\dos\config.status"
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

''
sub gen_crlf_check()

	outcomment "convert line endings CRLF to LF on some files"
	oute
	oute "copy ${WORK_PATH}\crlf.bas ${BUILD_PATH}\src"
	oute "copy ${WORK_PATH}\crlf.exe ${BUILD_PATH}\src"
	oute "copy ${WORK_PATH}\crlf.lst ${BUILD_PATH}\src"
	oute
	oute "IF NOT EXIST ${WORK_PATH}\crlf.exe goto ERROR"
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\src"
	oute
	oute "${BUILD_PATH}\src\crlf.exe check"
	oute "if errorlevel 1 goto ERROR"
	oute

end sub

''
sub gen_make_win( byref fbcset as string, byref exefbc as string, byref extraopts as string )

	dim lbl as string, f as string
	lbl = GetLabel( "MAKW" )
	f = "make_win"

	outcomment "make rtlib, gfxlib2, and compiler for windows"
	oute
	CheckProgress f, lbl
	oute
	oute "call setpath.bat " & fbcset
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\src"
	oute
	oute "cd rtlib\obj\win32"
	oute "make"
	oute "if errorlevel 1 goto ERROR"
	oute "make MULTITHREADED=1"
	oute "if errorlevel 1 goto ERROR"
	oute "copy libfb.a ..\..\..\..\lib\win32"
	oute "copy libfbmt.a ..\..\..\..\lib\win32"
	oute "copy fbrt0.o ..\..\..\..\lib\win32"
	oute "cd ..\..\.."
	oute
	oute "cd gfxlib2\obj\win32"
	oute "make"
	oute "if errorlevel 1 goto ERROR"
	oute "copy libfbgfx.a ..\..\..\..\lib\win32"
	oute "cd ..\..\.."
	oute
	oute "cd compiler\obj\win32"
	oute "make FBC=" & exefbc & " " & extraopts
	oute "if errorlevel 1 goto ERROR"
	oute
	oute "copy fbc_new.exe ..\..\..\..\fbc_win.exe"
	oute "copy fbc_new.exe ..\..\..\..\fbc.exe"
	oute "copy fbc_new.exe fbc_win_0.bak"
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

''
sub gen_merge( byref src_path as string, byref version as string, byref file as string )
	
	dim lbl as string, f as string
	lbl = GetLabel( "MRG" )
	f = "mrg" & file

	outcomment "merge in binaries from last distribution"
	oute
	CheckProgress f, lbl
	oute
	oute "${WORK_PATH}\merge.exe copy " & src_path & " ${BUILD_PATH} " & version & " " & file
	oute "if errorlevel 1 goto ERROR"
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

''
sub gen_make_dos( byref fbcset as string, byref exefbc as string, byref extraopts as string )

	dim lbl as string, f as string
	lbl = GetLabel( "MAKD" )
	f = "make_dos"

	outcomment "make rtlib, gfxlib2, and compiler for dos"
	oute
	CheckProgress f, lbl
	oute
	oute "call setpath.bat " & fbcset
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\src"
	oute
	oute "cd rtlib\obj\dos"
	oute "make"
	oute "if errorlevel 1 goto ERROR"
	''oute "mkdir mt"
	''oute "make MULTITHREADED=1"
	''oute "if errorlevel 1 goto ERROR"
	oute
	oute "copy libfb.a ..\..\..\..\lib\dos\libfb.a"
	'' !!! FIXME !!! - libfbmt.a should be allowed
	oute "copy libfb.a ..\..\..\..\lib\dos\libfbmt.a"
	oute "copy fbrt0.o ..\..\..\..\lib\dos"
	oute "cd ..\..\.."
	oute
	oute "cd gfxlib2\obj\dos"
	oute "make"
	oute "if errorlevel 1 goto ERROR"
	oute "copy libfbgfx.a ..\..\..\..\lib\dos"
	oute "cd ..\..\.."
	oute
	oute "cd compiler\obj\dos"
	oute "make FBC=" & exefbc  & " " & extraopts
	oute "if errorlevel 1 goto ERROR"
	oute
	oute "copy fbc_new.exe ..\..\..\..\fbc_dos.exe"
	oute "copy fbc_new.exe fbc_dos_0.bak"
	oute
	oute "cd ..\..\.."
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

''
sub gen_remake( byref fbcset as string, byref target as string, byval count as integer, byref exefbc as string, byref extraopts as string )

	dim lbl as string, f as string

	lbl = GetLabel( "RMK" )
	f = "rmk_" & left( target, 3 ) & str(count)
	
	outcomment "remake compiler from last made compiler #" & str(count)
	oute
	CheckProgress f, lbl
	oute
	oute "call setpath.bat " & fbcset
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\src\compiler\obj\" & target
	oute
	oute "make mostlyclean"
	oute "if errorlevel 1 goto ERROR"
	oute "make FBC=" & exefbc & " " & extraopts
	oute "if errorlevel 1 goto ERROR"
	oute "copy fbc_new.exe ..\..\..\..\fbc_" & left( target, 3 ) & ".exe"
	oute "copy fbc_new.exe ..\..\..\..\fbc.exe"
	oute "copy fbc_new.exe fbc_" & left( target, 3 ) & "_" & str(count) & ".bak"
	oute
	oute "cd ..\..\.."
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

''
sub gen_diff( byref target as string, byval count1 as integer, byval count2 as integer, byval start as integer )

	dim lbl as string, f as string

	lbl = GetLabel( "DIF" )
	f = "diff" & left( target, 3 ) 

	outcomment "compare the last two compilers"
	oute
	CheckProgress f, lbl
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\src\compiler\obj\" & target
	oute

	oute "${WORK_PATH}\diffexe.exe" _
		& " fbc_" & left( target, 3 ) & "_" & str(count1) & ".bak" _
		& " fbc_" & left( target, 3 ) & "_" & str(count2) & ".bak" _
		& " " & str( start )
	oute "if errorlevel 1 goto ERROR"

	oute
	oute "cd ..\..\.."
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

sub gen_test_suite_win( byref fbcset as string )

	dim lbl as string, f as string

	lbl = GetLabel( "TSTW" )
	f = "testsuiw"

	outcomment "do the test suite for WIN"
	oute
	oute "call setpath.bat " & fbcset
	oute
	CheckProgress f, lbl
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\tests"
	oute
	oute "make cunit-tests FBC=${BUILD_DRV}:/${BUILD_DIR}/fbc_win.exe"
	oute "if errorlevel 1 goto ERROR"
	oute "make clean"
	oute "if errorlevel 1 goto ERROR"
	oute
	oute "cd .."
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

sub gen_test_suite_dos( byref fbcset as string )

	dim lbl as string, f as string

	lbl = GetLabel( "TSTD" )
	f = "testsuid"

	outcomment "do the test suite for DOS"
	oute
	oute "call setpath.bat " & fbcset
	oute
	CheckProgress f, lbl
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\tests"
	oute
	oute "make cunit-tests FBC=${BUILD_DRV}:/${BUILD_DIR}/fbc_dos.exe OS=DOS"
	oute "if errorlevel 1 goto ERROR"
	oute "make clean OS=DOS"
	oute "if errorlevel 1 goto ERROR"
	oute
	oute "cd .."
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

sub gen_test_samples_win( byref fbcset as string )

	dim lbl as string, f as string

	lbl = GetLabel( "SMPW" )
	f = "testsmpw"

	outcomment "build all the samples for win"
	oute
	CheckProgress f, lbl
	oute
	oute "call setpath.bat " & fbcset
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\examples\manual"
	oute
	oute "..\..\fbc_win.exe samples.bas"
	oute "if errorlevel 1 goto ERROR"
	oute "samples.exe compile -error -fbc ../../fbc_win.exe"
	oute "if errorlevel 1 goto ERROR"
	oute "samples clean"
	oute "if errorlevel 1 goto ERROR"
	oute
	oute "cd ..\.."
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

sub gen_test_samples_dos( byref fbcset as string )

	dim lbl as string, f as string

	lbl = GetLabel( "SMPD" )
	f = "testsmpd"

	outcomment "build all the samples for dos"
	oute
	CheckProgress f, lbl
	oute
	oute "call setpath.bat " & fbcset
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\examples\manual"
	oute
	oute "..\..\fbc_dos.exe samples.bas"
	oute "if errorlevel 1 goto ERROR"
	oute "samples.exe compile -error -fbc ../../fbc_dos.exe"
	oute "if errorlevel 1 goto ERROR"
	oute "samples clean"
	oute "if errorlevel 1 goto ERROR"
	oute
	oute "cd ..\.."
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

sub gen_examples( byref fbcset as string )

	dim lbl as string, f as string

	lbl = GetLabel( "EXAW" )
	f = "testexaw"

	outcomment "build all examples for win"
	oute
	CheckProgress f, lbl
	oute
	oute "call setpath.bat " & fbcset
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\examples"
	oute
	oute "make FBC=${BUILD_DRV}:/${BUILD_DIR}/fbc_win.exe"
	oute "if errorlevel 1 goto ERROR"
	oute "make clean"
	oute "if errorlevel 1 goto ERROR"
	oute
	oute "cd .."
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

sub gen_make_win_install( byref fbcset as string )

	dim lbl as string, f as string

	lbl = GetLabel( "INST" )
	f = "wininst"
	
	outcomment "build the windows installer exe"
	oute
	CheckProgress f, lbl
	oute
	oute "call setpath.bat " & fbcset
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}\src\contrib\w32_inst"
	oute
	oute "mkdir g:\temp" '' !!!
	oute "mkdir g:\tmpinst" '' !!!
	oute
	oute "set TMP=g:\temp" '' !!!
	oute "set TEMP=g:\temp" '' !!!
	oute
	oute "make FBC=g:/freebasic/fbc_win.exe MAKENSIS=""f:/NSIS/makensis.exe"" $INSTDIR=g:/tmpinst" '' !!!
	oute "if errorlevel 1 goto ERROR"
	oute "make Setup.exe MAKENSIS=""f:/NSIS/makensis.exe"" $INSTDIR=g:/tmpinst" '' !!!
	oute "if errorlevel 1 goto ERROR"
	oute
	MarkProgress f
	oute
	oute ":" & lbl
	oute

end sub

''
sub gen_all_done()

	outcomment "ALL DONE"
	oute
	oute "copy ${WORK_PATH}\mkdist.bat ${BUILD_PATH}"
	oute "if errorlevel 1 goto ERROR"
	oute
	oute "${BUILD_DRV}:"
	oute "cd \${BUILD_DIR}"
	oute
	MarkProgress "all_done"
	oute "goto END"
	oute

end sub

''
sub gen_error_handler()

	outcomment "Error handler"
	oute ":ERROR"
	oute "@echo =============================================="
	oute "@echo ===============     BUILD ERROR    ==========="
	oute "@echo =============================================="
	oute "goto END"
	oute

end sub

''
sub gen_end_handler()

	oute
	outcomment "END"
	oute ":END"
	oute

end sub

''	--------------------------------------

	dim as string merge_src, merge_lst

	batch_file = "build.bat"
	
	'' !!!!

	select case command(1)
	case "SVN"
		revision = "HEAD"
		merge_src = "g:/freebasic.svn"
		merge_lst = "current"

	case "0.20.X"
		revision = "branches/fbc-0_20-branch/FreeBASIC"
		merge_src = "g:/freebasic.201"
		merge_lst = "current"

	case "0.20.1"
		revision = "tags/release_0_20_1-final/FreeBASIC"
		merge_src = "g:/freebasic.201"
		merge_lst = "fbc-0.20.1"

	case else
		print "Unrecognized version ID"
		end 1

	end select


	svn_base_url = "https://fbc.svn.sourceforge.net/svnroot/fbc/" 
	svn_exe = "f:\subversion\bin\svn.exe"
	build_drv = "g"
	build_dir = "FreeBASIC"
	build_path = build_drv & ":\" & build_dir
	work_path = "g:\build"
	stat_path = "g:\build\stat"

''	--------------------------------------

	if revision = "HEAD" then
		svn_url = svn_base_url & "trunk/FreeBASIC"
	else
		svn_url = svn_base_url & revision
	end if

''	--------------------------------------

	if( fileexists( batch_file ) ) then
		kill batch_file
	end if

	gen_startup()

	gen_svn_checkout( TRUE )

	gen_copy_extra_files()

	gen_autoconf()

	gen_configure_win( "FB181", "CFLAGS=-O2" , "--enable-standalone --enable-crosscomp-dos --enable-crosscomp-cygwin" )
	gen_configure_dos( "FB181DOS", "CFLAGS=-O2 CC=gcc --target=i386-pc-msdosdjgpp target_alias=i386-pc-msdosdjgpp", "CC=gcc --target=i386-pc-msdosdjgpp target_alias=i386-pc-msdosdjgpp --enable-standalone" )

	gen_merge( merge_src, merge_lst, "win32" )
	gen_merge( merge_src, merge_lst, "dos32" )

	gen_crlf_check()

	gen_make_dos( "FB181DOS", "fbc_dos.exe", "" )
	gen_make_win( "FB181", "fbc_win.exe", "" )

	gen_remake( "FBRELDOS", "dos", 1, "../../../../fbc_dos.exe", "FB_BFD=1 BFD_VER=217" )
	gen_remake( "FBRELDOS", "dos", 2, "../../../../fbc_dos.exe", "FB_BFD=1 BFD_VER=217" )

	gen_remake( "FBREL", "win32", 1, "../../../../fbc_win.exe", "FB_BFD=1 BFD_VER=217" )
	gen_remake( "FBREL", "win32", 2, "../../../../fbc_win.exe", "FB_BFD=1 BFD_VER=217" )

	gen_diff( "dos", 1, 2, 0 )
	gen_diff( "win32", 1, 2, 256 )

	gen_test_suite_win( "FBREL" )
	gen_test_suite_dos( "FBRELDOS" )

	gen_test_samples_win( "FBREL" )
	gen_test_samples_dos( "FBRELDOS" )

	gen_examples( "FBREL" )

	gen_make_win_install( "FBREL" )

	'' gen_distro()

	gen_all_done()
	gen_error_handler()
	gen_end_handler()

''	--------------------------------------

/'
    "--host=i386-pc-msdosdjgpp host_alias=i386-pc-msdosdjgpp" _
	& " --build=i386-pc-msdosdjgpp build_alias=i386-pc-msdosdjgpp" _
	& " --target=i386-pc-msdosdjgpp target_alias=i386-pc-msdosdjgpp" _
	& " CFLAGS=-O2"
'/


