#include once "file.bi"
#include once "dir.bi"

dim files(1 to 20000) as string
dim nfiles as integer
dim missing(1 to 20000) as string
dim nmissing as integer
dim x as string
dim i as integer
dim src as string
dim dst as string
dim ver as string
dim fil as string
dim ret as integer

'' LINUX
'' src = "/acutus02/hd3/FreeBASIC/"
'' dst = "/FreeBASIC/"
'' ver = "fbc-0.18.1" & "/"
'' fil = "linux"

'' WINDOWS
'' src = "g:/FreeBASIC.svn/"
'' dst = "g:/FreeBASIC/"
'' ver = "current" & "/"
'' fil = "win32"

''
if( command(5) = "" ) then
	print "manifest {check|copy} source destination version file"
	print "manifest {dist} prefix destination version file"
	end 1
end if

src = command(2) & "/"
dst = command(3) & "/"
ver = command(4) & "/"
fil = command(5)

'' Read the manifest
print "src = "; src
print "dst = "; dst
print "ver = "; ver
print "fil = "; fil
print "Reading '" & dst & "manifest/" & ver & fil & ".lst" & "'"
if( open( dst & "manifest/" & ver & fil & ".lst" for input as #1 ) = 0 ) then
	nfiles = 0
	while eof(1) = 0
		line input #1, x
		nfiles += 1
		files( nfiles ) = x
	wend
	close #1
else
	print "Unable to open " & dst & "manifest/" & ver & fil & ".lst"
	end 1
end if

select case lcase(command(1))
case "dist"

	'' Create as distro list
	print "Writing '" & dst & "manifest/" & ver & "dist-" & fil & ".lst" & "'"
	open dst & "manifest/" & ver & "dist-" & fil & ".lst" for output as #1
	for i = 1 to nfiles
		print #1, src & files(i)
	next 
	close #1

case "check"

	for i = 1 to nfiles
		if( fileexists( dst & files(i) ) = 0 ) then
			print "missing '" & files(i) & "'"
			nmissing += 1
			ret = 1
		end if
	next	

case "copy"

	'' Check for files
	for i = 1 to nfiles
		if( fileexists( dst & files(i) ) = 0 ) then
			if( fileexists( src & files(i) ) = 0 ) then
				print "missing '" & files(i) & "'"
				nmissing += 1
				missing(nmissing) = files(i)
				ret = 1
			else
				print "copying '" & files(i) & "'";

				'' make the directory if needed
				scope
					dim p as string, j as integer, k as integer = 1
					j = instr( k, files(i), any "/\" )
					while( j > 0 )

						p = dst & left( files(i), j - 1 )

						if( dir( p, fbDirectory ) = "" ) then
							print "Making '" & p & "'"
							mkdir p
						end if

						k = j + 1
						j = instr( k, files(i), "/" )
					wend
				end scope

				if( filecopy( src & files(i), dst & files(i) ) = 0 ) then
					print "OK"
				else
					print "FAILED!!!"
					nmissing += 1
					missing(nmissing) = files(i)
					ret = 1
				end if
			end if
		end if
	next

	if( nmissing > 0 ) then
		for i = 1 to nmissing
			print "missing '" & missing(i) & "'"
		next
		print "missing "; nmissing; " files"
	end if

case else
	print "Invalid command '" & command(1) & "'"

end select

end ret
